package se.hig.jdalmas;

import java.util.LinkedList;
import java.util.List;
import java.util.Stack;

import se.sics.prologbeans.PBTerm;

public class Agent extends GenericComponent {
	protected String agentID;

	/**
	 * @param agentID
	 */
	public Agent(String agentID) {
		this.agentID = agentID;
	}
	
	/**
	 * @return the agentID
	 */
	public String getAgentID() {
		return agentID;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return this.agentID;
	}

	public static PBTerm createAgentListPrologTerm(List<Agent> agentList) {
		Stack<Agent> agentStack = new Stack<Agent>();
		for(Agent agent : agentList)
			agentStack.push(agent);
		PBTerm agentTerm = PBTerm.NIL;
		while (!agentStack.isEmpty()) {
			Agent agent = agentStack.pop();
			agentTerm = PBTerm.makeTerm(createAgentTerm(agent.agentID),agentTerm);
		}
		return agentTerm;
	}
	
	public static List<Agent> createAgentList(PBTerm agentListTerm) {
		List<Agent> agentList = new LinkedList<Agent>();
		while (!agentListTerm.isEmptyList()) {
			Agent agent = createAgent(agentListTerm.head());
			agentList.add(agent);
			agentListTerm = agentListTerm.tail();
		}
		return agentList;
	}

	public static List<Agent> createEmptyAgentList() {
		return new LinkedList<Agent>();
	}

	public static Agent createAgent(String agentID) {
		return new Agent(agentID);
	}

	public static Agent createAgent(PBTerm agentTerm) {
		return new Agent(agentTerm.getName());
	}

	public static PBTerm createAgentTerm(String agentID) {
		return PBTerm.makeAtom(agentID);
	}
}