package se.hig.jdalmas;

import se.hig.jdalmas.norms.NormSystem;
import se.sics.prologbeans.PBTerm;

public class DnrDALMAS extends GenericComponent {
	protected DDALMAS dDALMAS;
	protected NormSystem normSystem;
	
	/**
	 * @param ddalmas
	 * @param normSystem
	 */
	public DnrDALMAS(DDALMAS ddalmas, NormSystem normSystem) {
		this.dDALMAS = ddalmas;
		this.normSystem = normSystem;
	}

	/**
	 * @return the dDALMAS
	 */
	public DDALMAS getDDALMAS() {
		return dDALMAS;
	}

	/**
	 * @param ddalmas the dDALMAS to set
	 */
	public void setDDALMAS(DDALMAS ddalmas) {
		this.dDALMAS = ddalmas;
	}

	/**
	 * @return the normSystem
	 */
	public NormSystem getNormSystem() {
		return normSystem;
	}

	/**
	 * @param normSystem the normSystem to set
	 */
	public void setNormSystem(NormSystem normSystem) {
		this.normSystem = normSystem;
	}

	public Agent findAgent(String agentID) {
		return this.getDDALMAS().findAgent(agentID);
	}

	public Act findAct(String actID, String [] actParameters) {
		return this.getDDALMAS().findAct(actID,actParameters);
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "[" + this.dDALMAS + "," + this.normSystem + "]";
	}

	public static DnrDALMAS createEmptyDnrDALMAS(String normSystemID) {
		return createDnrDALMAS(DDALMAS.createEmptyDDALMAS(),
				NormSystem.createEmptyNormSystem(normSystemID));
	}
	
	public static DnrDALMAS createDnrDALMAS(PBTerm dnrDALMASTerm) {
		DDALMAS dDALMAS = DDALMAS.createDDALMAS(dnrDALMASTerm.getArgument(1));
		NormSystem normSystem = 
				NormSystem.createNormSystem(dnrDALMASTerm.getArgument(2));
		return createDnrDALMAS(dDALMAS,normSystem);
	}

	public static DnrDALMAS createDnrDALMAS(DDALMAS dDALMAS, NormSystem normSystem) {
		return new DnrDALMAS(dDALMAS,normSystem);
	}
	
	public static PBTerm createPrologTerm(DnrDALMAS dnrDALMAS) {
		PBTerm [] args = new PBTerm[2];
		args[0] = DDALMAS.createPrologTerm(dnrDALMAS.getDDALMAS());
		args[1] = NormSystem.createPrologTerm(dnrDALMAS.getNormSystem());
		return PBTerm.makeTerm(DNR_DALMAS,args);
	}
	
}