package se.hig.jdalmas;

import se.sics.prologbeans.PBTerm;

public class DnrDALMASState extends GenericComponent {
	protected KnowledgeBase knowledgeBase;
	protected DnrDALMAS dnrDALMAS;

	/**
	 * @param knowledgeBase
	 * @param dnrDALMAS
	 */
	public DnrDALMASState(KnowledgeBase knowledgeBase, DnrDALMAS dnrDALMAS) {
		this.knowledgeBase = knowledgeBase;
		this.dnrDALMAS = dnrDALMAS;
	}

	/**
	 * @return the dnrDALMAS
	 */
	public DnrDALMAS getDnrDALMAS() {
		return dnrDALMAS;
	}
	
	/**
	 * @param dnrDALMAS the dnrDALMAS to set
	 */
	public void setDnrDALMAS(DnrDALMAS dnrDALMAS) {
		this.dnrDALMAS = dnrDALMAS;
	}
	
	/**
	 * @return the knowledgeBase
	 */
	public KnowledgeBase getKnowledgeBase() {
		return knowledgeBase;
	}
	
	/**
	 * @param knowledgeBase the knowledgeBase to set
	 */
	public void setKnowledgeBase(KnowledgeBase knowledgeBase) {
		this.knowledgeBase = knowledgeBase;
	}

	public Agent findAgent(String agentID) {
		return this.getDnrDALMAS().findAgent(agentID);
	}

	public Act findAct(String actID, String [] actParameters) {
		return this.getDnrDALMAS().findAct(actID,actParameters);
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "[" + this.knowledgeBase + "," + this.dnrDALMAS + "]";
	}
	
	public static PBTerm createPrologTerm(DnrDALMASState state) {
		PBTerm [] args = {
				KnowledgeBase.createPrologTerm(state.getKnowledgeBase()),
				DnrDALMAS.createPrologTerm(state.getDnrDALMAS())
		};
		return PBTerm.makeTerm(DNR_DALMAS_STATE,args);
	}

	public static DnrDALMASState createState(PBTerm prologTerm) {
		PBTerm kbTerm = prologTerm.getArgument(1);
		PBTerm dnrDALMASTerm = prologTerm.getArgument(2);
		KnowledgeBase knowledgeBase = KnowledgeBase.createKnowledgeBase(kbTerm);
		DnrDALMAS dnrDALMAS = DnrDALMAS.createDnrDALMAS(dnrDALMASTerm);
		return createState(knowledgeBase,dnrDALMAS);
	}

	public static DnrDALMASState createState(KnowledgeBase knowledgeBase, 
			DnrDALMAS dnrDALMAS) {
		return new DnrDALMASState(knowledgeBase,dnrDALMAS);
	}
	
	public static DnrDALMASState createEmptyState(String normSystemID) {
		return createState(KnowledgeBase.createEmptyKnowledgeBase(),
				DnrDALMAS.createEmptyDnrDALMAS(normSystemID));
	}
}