package se.hig.jdalmas;

import java.io.IOException;
import se.hig.jdalmas.control.PrologSessionHandler;

public abstract class GenericComponent {
	public static final String K_EVENT_RUN = "run";
	public static final String DNR_DALMAS_SIT = "dnrDALMAS_sit";
	public static final String DNR_DALMAS_STATE = "dnrDALMAS_state";
	public static final String DNR_DALMAS = "dnrDALMAS";
	public static final String D_DALMAS = "dDALMAS";
	public static final String FEASIBLE_ACT_PREDICATE = "feasibleActPredicate";
	public static final String PERMISSIBLE_ACT_PREDICATE = "permissibleActPredicate";
	public static final String UTILITY_FUNCTION_PREDICATE = "utilityFunctionPredicate";
	public static final String CHOICE_SET_PREDICATE = "choiceSetPredicate";
	public static final String TURN_OPERATOR_PREDICATE = "turnOperatorPredicate";
	public static final String TIE_BREAK_PREDICATE = "tieBreakPredicate";
	public static final String EMPTY = "empty";
	public static final String EMPTY_GCSET = "emptyGCSet";
	public static final String ADD_TO_GCSET = "addToGCSet";
	public static final String REMOVE_FIRST_FROM_GCSET = "removeFirstFromGCSet";
	public static final String NEXT_SITUATION = "nextSituation";
	public static final String FEASIBLE_ACTS = "feasibleActs";
	public static final String DEONTIC_STRUCTURE = "deonticStructure";
	public static final String PREFERENCE_STRUCTURE = "preferenceStructure";
	public static final String TIE_BREAKER = "tieBreaker";
	public static final String CHOICE_SET = "choiceSet";
	public static final String NORM_SYSTEM = "ns";
	public static final String NORM = "n";
	public static final String MOVE = "move";
	public static final String TYPE = "t";

	protected static PrologSessionHandler prologSessionHandler = 
		PrologSessionHandler.getInstance();

	protected static void connect() throws IOException {
//		System.out.print("* Connecting... ");
		prologSessionHandler.getSession().connect();
//		System.out.println("Done!");		
	}

	protected static void disconnect() {
//		System.out.print("* Disconnecting... ");
		prologSessionHandler.getSession().disconnect();
//		System.out.println("Done!");		
	}
	
	protected String toString(String [] strings) {
		StringBuffer stringBuffer = new StringBuffer();
		int i;
		for(i=0; i<strings.length-1; i++) {
			stringBuffer.append(strings[i]+",");
		}
		stringBuffer.append(strings[i]);
		return stringBuffer.toString();
	}
	
}
