package se.hig.jdalmas;

import java.util.List;
import java.util.LinkedList;

import se.hig.jdalmas.Knowledge;
import se.hig.jdalmas.KnowledgeBase;
import se.sics.prologbeans.PBTerm;

public class ListKB {
	public static List<Knowledge> createEmptyListKB() {
		return new LinkedList<Knowledge>();
	}

	public static List<Knowledge> createListKB(KnowledgeBase knowledgeBase) {
		PBTerm kbTerm = knowledgeBase.getPrologTerm();
		List<Knowledge> listKB = new LinkedList<Knowledge>();
		while (!kbTerm.isEmptyList()) {
			Knowledge fact = Knowledge.createKnowledge(kbTerm.head());
			listKB.add(fact);
			kbTerm = kbTerm.tail();
		}
		return listKB;
	}

	public static KnowledgeBase createKnowledgeBase(List<Knowledge> listKB) {
		PBTerm kbTerm = PBTerm.NIL;
		for (Knowledge knowledge : listKB) {
			kbTerm = PBTerm.makeTerm(knowledge.getPrologTerm(),kbTerm);
		}
		return KnowledgeBase.createKnowledgeBase(kbTerm);
	}

	public static void addKnowledge(List<Knowledge> listKB, Knowledge knowledge) {
		listKB.add(knowledge);
	}

	public static void deleteKnowledge(List<Knowledge> listKB, Knowledge knowledge) {
		listKB.remove(knowledge);
	}
	
//	/* (non-Javadoc)
//	 * @see java.lang.Object#toString()
//	 */
//	@Override
//	public String toString() {
//		StringBuffer kbString = new StringBuffer();
//		kbString.append('[');
//		for (int i=0; i<facts.size(); i++) {
//			kbString.append(facts.get(i).toString());
//			if (i<facts.size()-1)
//				kbString.append(",");
//		}
//		kbString.append(']');
//		return kbString.toString();
//	}
//
}
