package se.hig.jdalmas.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import se.hig.jdalmas.exceptions.DnrDALMASException;

public class AddActFrame extends JFrame {
	private JDALMASGUI parent;
	private JLabel actIDLabel = new JLabel("Act ID");
	private JPanel centerPanel = new JPanel();
	private JTextField actIDTxt = new JTextField();
	private JTextField actParameterTxt = new JTextField();
	private JButton addActBtn = new JButton("Add act");
	
	public AddActFrame(JDALMASGUI parent) {
		super("Add act");
		this.parent = parent;
		initFrame();
	}

	private void initFrame() {
		this.setLayout(new BorderLayout());
		// --- CENTER PANEL ---
		centerPanel.setLayout(new BoxLayout(centerPanel, BoxLayout.Y_AXIS));
		centerPanel.add(actIDLabel);
		centerPanel.add(actIDTxt);
		centerPanel.add(actParameterTxt);
		
		// --- MAIN FRAME ---		
		this.add(centerPanel, BorderLayout.CENTER);
		addActBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				String actID = actIDTxt.getText();
				String actParameterString = actParameterTxt.getText();
				try {
					parent.addAct(actID,actParameterString);
				} catch (DnrDALMASException de) {
					JOptionPane.showMessageDialog(centerPanel, 
							de.getMessage(),"ERROR",JOptionPane.ERROR_MESSAGE);					
				}
				AddActFrame.this.dispose();
			}
		});
		this.add(addActBtn, BorderLayout.SOUTH);
		this.pack();
	}

}
