package se.hig.jdalmas.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import se.hig.jdalmas.exceptions.DnrDALMASException;

public class AddAgentFrame extends JFrame {
	private static int nextInt = 0;
	private JDALMASGUI parent;
	private JLabel agentIDLabel = new JLabel("Agent ID");
	private JPanel centerPanel = new JPanel();
	private JTextField agentIDTxt = new JTextField();
	private JButton addAgentBtn = new JButton("Add agent");
	
	public AddAgentFrame(JDALMASGUI parent) {
		super("Add agent");
		this.parent = parent;
		initFrame();
	}

	private void initFrame() {
		this.setLayout(new BorderLayout());
		// --- CENTER PANEL ---
		agentIDTxt.setText("agent" + nextInt++);
		centerPanel.setLayout(new BoxLayout(centerPanel, BoxLayout.Y_AXIS));
		centerPanel.add(agentIDLabel);
		centerPanel.add(agentIDTxt);
		
		// --- MAIN FRAME ---		
		this.add(centerPanel, BorderLayout.CENTER);
		addAgentBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				String agentID = agentIDTxt.getText();
				try {
					parent.addAgent(agentID);
				} catch (DnrDALMASException de) {
					JOptionPane.showMessageDialog(centerPanel, 
							de.getMessage(),"ERROR",JOptionPane.ERROR_MESSAGE);					
				}
				AddAgentFrame.this.dispose();
			}
		});
		this.add(addAgentBtn, BorderLayout.SOUTH);
		this.pack();
	}

}
