package se.hig.jdalmas.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import se.hig.jdalmas.exceptions.DnrDALMASException;

public class AddConsequenceFrame extends JFrame {
	private JDALMASGUI parent;
	
	private Box centerBox = Box.createHorizontalBox();
	private Box consequenceIDBox = Box.createVerticalBox();	
	private JLabel consequenceIDLabel = new JLabel("Consequence ID");
	private JTextField consequenceIDTxt = new JTextField();
	private Box consequenceModuleBox = Box.createVerticalBox();
	private JLabel consequenceModuleLabel = new JLabel("Module");
	private JTextField consequenceModuleTxt = new JTextField();
	private Box consequenceFunctorBox = Box.createVerticalBox();	
	private JLabel consequenceFunctorLabel = new JLabel("Functor");
	private JTextField consequenceFunctorTxt = new JTextField();
	private Box consequenceAgentArityBox = Box.createVerticalBox();	
	private JLabel consequenceAgentArityLabel = new JLabel("Number of agent arguments");
	private JTextField consequenceAgentArityTxt = new JTextField();
	private Box consequenceArityBox = Box.createVerticalBox();	
	private JTextField consequenceArityTxt = new JTextField();
	private JLabel consequenceArityLabel = new JLabel("Number of other arguments");
	
	private JButton addConsequenceBtn = new JButton("Add consequence");

	public AddConsequenceFrame(JDALMASGUI parent) {
		super("Add consequence");
		this.parent = parent;
		initFrame();
	}

	private void initFrame() {
		this.setLayout(new BorderLayout());
				
		// --- CENTER BOX ---
		centerBox.add(consequenceIDBox);
		consequenceIDBox.add(consequenceIDLabel);
		consequenceIDBox.add(consequenceIDTxt);
		centerBox.add(consequenceModuleBox);
		consequenceModuleBox.add(consequenceModuleLabel);
		consequenceModuleBox.add(consequenceModuleTxt);
		consequenceModuleTxt.setText("user");
		centerBox.add(consequenceFunctorBox);		
		consequenceFunctorBox.add(consequenceFunctorLabel);
		consequenceFunctorBox.add(consequenceFunctorTxt);
		centerBox.add(consequenceAgentArityBox);				
		consequenceAgentArityBox.add(consequenceAgentArityLabel);
		consequenceAgentArityBox.add(consequenceAgentArityTxt);
		centerBox.add(consequenceArityBox);				
		consequenceArityBox.add(consequenceArityLabel);
		consequenceArityBox.add(consequenceArityTxt);
		
		// --- MAIN FRAME ---
		this.add(centerBox,BorderLayout.CENTER);
		addConsequenceBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				try {
					String consequenceID = consequenceIDTxt.getText();
					String consequenceModule = consequenceModuleTxt.getText();
					String consequenceFunctor = consequenceFunctorTxt.getText();
					int consequenceAgentArity = 
						Integer.parseInt(consequenceAgentArityTxt.getText());
					int consequenceArity = Integer.parseInt(consequenceArityTxt.getText());					
					parent.addConsequenceToConsequenceSet(consequenceID,
							consequenceModule,consequenceFunctor,
							consequenceAgentArity,consequenceArity);
					parent.displayConsequenceSet();
					AddConsequenceFrame.this.dispose();
				} catch (NumberFormatException nfe) {
					JOptionPane.showMessageDialog(AddConsequenceFrame.this, 
							nfe.getMessage(),"ERROR",JOptionPane.ERROR_MESSAGE);					
				} catch (DnrDALMASException de) {
					JOptionPane.showMessageDialog(AddConsequenceFrame.this, 
							de.getMessage(),"ERROR",JOptionPane.ERROR_MESSAGE);					
				}
			}
		});
		this.add(addConsequenceBtn,BorderLayout.SOUTH);
		this.pack();
	}
}
