/**
 * 
 */
package se.hig.jdalmas.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;

import se.hig.jdalmas.exceptions.DnrDALMASException;

/**
 * @author mbm
 *
 */
public class AddNormFrame extends JFrame {
	private static int nextInt = 0;
	private final int W = 60;
	private final int H = 20;
	
	private JDALMASGUI parent;
	
	private JLabel normIDLabel = new JLabel("Norm ID:");
	private JTextField normIDTxt = new JTextField();
	private JLabel arrowLabel = new JLabel(" --> ");
	
	private Box northBox = Box.createHorizontalBox();
	private Box centerBox = Box.createHorizontalBox();
	
	private JComboBox groundOpBox = null;
	private JList groundConditionList = null;
	private JScrollPane groundConditionScrollPane = new JScrollPane();
	private JTextField groundConditionParameterTxt = new JTextField();
	
	private JComboBox consequenceOpBox = null;
	private JList consequenceConditionList = null;
	private JScrollPane consequenceConditionScrollPane = new JScrollPane();
	private JTextField consequenceConditionParameterTxt = new JTextField();
	
	private JButton addNormBtn = new JButton("Add norm");

	public AddNormFrame(JDALMASGUI parent) {
		super("Add elementary norm");
		this.parent = parent;
		initFrame();
	}

	private void initFrame() {
		this.setLayout(new BorderLayout());
		// --- NORTH BOX ---
		northBox.add(normIDLabel);
		normIDTxt.setText("n" + nextInt++);
		normIDTxt.setPreferredSize(new Dimension(W,H));
		northBox.add(normIDTxt);
		this.add(northBox, BorderLayout.NORTH);
		
		// --- CENTER BOX ---
		groundOpBox = new JComboBox(parent.getGroundOps());
		centerBox.add(groundOpBox);
		
		groundConditionList = new JList(parent.getGroundIDSet());
		groundConditionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		groundConditionList.setSelectedIndex(0);
		groundConditionScrollPane.setViewportView(groundConditionList);
		centerBox.add(groundConditionScrollPane);
		centerBox.add(groundConditionParameterTxt);
		groundConditionParameterTxt.setPreferredSize(new Dimension(W,H));

		centerBox.add(arrowLabel);
		consequenceOpBox = new JComboBox(parent.getConsequenceOps());
		centerBox.add(consequenceOpBox);
		consequenceConditionList = new JList(parent.getConsequenceIDSet());
		consequenceConditionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		consequenceConditionList.setSelectedIndex(0);
		consequenceConditionScrollPane.setViewportView(consequenceConditionList);
		centerBox.add(consequenceConditionScrollPane);
		centerBox.add(consequenceConditionParameterTxt);
		consequenceConditionParameterTxt.setPreferredSize(new Dimension(W,H));
		
		// --- MAIN FRAME ---		
		this.add(centerBox, BorderLayout.CENTER);
		addNormBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				try {
					String normID = normIDTxt.getText();
				System.out.println(groundConditionList.getSelectedValue().toString());
				System.out.println(consequenceConditionList.getSelectedValue().toString());
					
					int groundOpIndex = groundOpBox.getSelectedIndex();
					String groundCondition = groundConditionList.getSelectedValue().toString();
					String groundConditionParameterString = groundConditionParameterTxt.getText();
					int consequenceOpIndex = consequenceOpBox.getSelectedIndex()+1;
					String consequenceCondition = consequenceConditionList.getSelectedValue().toString();
					String consequenceConditionParameterString = consequenceConditionParameterTxt.getText();
					parent.addElementaryNorm(normID,
							groundOpIndex,groundCondition,groundConditionParameterString,
							consequenceOpIndex,consequenceCondition,consequenceConditionParameterString);
					parent.displayNormSet();
					AddNormFrame.this.dispose();
				} catch (DnrDALMASException de) {
					JOptionPane.showMessageDialog(centerBox, 
							de.getMessage(),"ERROR", JOptionPane.ERROR_MESSAGE);					
				}
			}
		});
		addNormBtn.setPreferredSize(new Dimension(W,H));
		this.add(addNormBtn, BorderLayout.SOUTH);
		this.pack();
	}
}
