package se.hig.jdalmas.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.Arrays;
import java.util.Observable;
import java.util.Observer;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.MouseInputAdapter;

import se.hig.jdalmas.GenericComponent;
import se.hig.jdalmas.exceptions.DnrDALMASException;
import se.hig.jdalmas.control.DnrDALMASController;

public class JDALMASGUI extends JPanel implements Observer {
	protected DnrDALMASController dnrDALMASController = null;
	public final int WIDTH = 80;
	public final int HEIGHT = 60;
	protected Box centerBox = Box.createVerticalBox();
	protected Box dnrDALMASBox = Box.createVerticalBox();
	protected Box dDALMASBox = Box.createHorizontalBox();
	protected Box normSystemBox = Box.createHorizontalBox();
	protected JLabel agentsLabel = new JLabel("Agent Set");
	protected Box agentsBox = Box.createVerticalBox();
	protected JList agentsList = new JList();
	protected JScrollPane agentsScrollPane = new JScrollPane();
	protected JButton addAgentBtn = new JButton("New...");
	protected JLabel actsLabel = new JLabel("Act Set");
	protected Box actsBox = Box.createVerticalBox();
	protected JList actsList = new JList();
	protected JScrollPane actsScrollPane = new JScrollPane();
	protected JButton addActBtn = new JButton("New...");
	protected JLabel predicatesLabel = new JLabel("Predicates");
	protected Box predicatesBox = Box.createVerticalBox();
	protected Box primaryPredicatesBox = Box.createVerticalBox();
	protected Box secondaryPredicatesBox = Box.createVerticalBox();
//	protected PredicatePanel actResultPredicatePanel = 
//		new PredicatePanel("actResultPredicate");
	protected PredicatePanel choiceSetPredicatePanel = 
		new PredicatePanel(GenericComponent.CHOICE_SET_PREDICATE);
	protected PredicatePanel feasibleActPredicatePanel = 
		new PredicatePanel(GenericComponent.FEASIBLE_ACT_PREDICATE);
	protected PredicatePanel permissibleActPredicatePanel = 
		new PredicatePanel(GenericComponent.PERMISSIBLE_ACT_PREDICATE);
	protected PredicatePanel tieBreakPredicatePanel = 
		new PredicatePanel(GenericComponent.TIE_BREAK_PREDICATE);
	protected PredicatePanel turnOperatorPredicatePanel = 
		new PredicatePanel(GenericComponent.TURN_OPERATOR_PREDICATE);
	protected PredicatePanel utilityFunctionPredicatePanel = 
		new PredicatePanel(GenericComponent.UTILITY_FUNCTION_PREDICATE);
	protected JScrollPane predicatesScrollPane = new JScrollPane();
	protected JLabel normsLabel = new JLabel("Norm-set");
	protected Box normsBox = Box.createVerticalBox();
	protected JList normsList = new JList();
	protected JScrollPane normsScrollPane = new JScrollPane();
	protected JButton addNormBtn = new JButton("New...");
	protected JLabel groundsLabel = new JLabel("Ground-set");
	protected Box groundsBox = Box.createVerticalBox();
	protected JList groundsList = new JList();
	protected JScrollPane groundsScrollPane = new JScrollPane();
	protected JButton addGroundBtn = new JButton("New...");
	protected JLabel consequencesLabel = new JLabel("Consequence-set");
	protected Box consequencesBox = Box.createVerticalBox();
	protected JList consequencesList = new JList();
	protected JScrollPane consequencesScrollPane = new JScrollPane();
	protected JButton addConsequenceBtn = new JButton("New...");
	protected Box situationBox = Box.createHorizontalBox();
	protected Box knowledgeBaseBox = Box.createVerticalBox();
	protected JScrollPane knowledgeScrollPane = new JScrollPane();
	protected JTextArea knowledgeTxt = new JTextArea();
	protected Box agentToMoveBox = Box.createVerticalBox();
	protected JLabel agentToMoveLabel = new JLabel();

	public JDALMASGUI() {
		// --- DDALMAS BOX ---
		agentsList.addMouseListener(new MouseInputAdapter() {
			public void mouseClicked(MouseEvent me) {
				String agentToMove = (String)agentsList.getSelectedValue();
				dnrDALMASController.setAgentToMove(agentToMove);
//				displayAgentToMove();
			}
		});
		agentsScrollPane.setViewportView(agentsList);
		agentsBox.setPreferredSize(new Dimension(2*WIDTH,4*HEIGHT));
		agentsBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.darkGray),
		"Agent-set"));
		agentsBox.add(agentsScrollPane);
		agentsBox.add(addAgentBtn);
		addAgentBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				AddAgentFrame addAgentFrame = new AddAgentFrame(JDALMASGUI.this);
				addAgentFrame.setVisible(true);
			}
		});
		dDALMASBox.add(agentsBox);

		actsScrollPane.setViewportView(actsList);
		actsBox.setPreferredSize(new Dimension(2*WIDTH,4*HEIGHT));
		actsBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.darkGray),
		"Act-set"));
		actsBox.add(actsScrollPane);
		actsBox.add(addActBtn);
		addActBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				AddActFrame addActFrame = new AddActFrame(JDALMASGUI.this);
				addActFrame.setVisible(true);
			}
		});
		dDALMASBox.setBorder(BorderFactory.createLineBorder(Color.yellow));
		dDALMASBox.add(actsBox);

		primaryPredicatesBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.darkGray),
		"Primary predicates"));
//		primaryPredicatesBox.add(actResultPredicatePanel);
		primaryPredicatesBox.add(feasibleActPredicatePanel);
		primaryPredicatesBox.add(turnOperatorPredicatePanel);
		primaryPredicatesBox.add(tieBreakPredicatePanel);
		primaryPredicatesBox.add(utilityFunctionPredicatePanel);
		secondaryPredicatesBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.darkGray),
		"Secondary predicates"));
		secondaryPredicatesBox.add(choiceSetPredicatePanel);
		secondaryPredicatesBox.add(permissibleActPredicatePanel);
		predicatesBox.setPreferredSize(new Dimension(6*WIDTH,4*HEIGHT));
		predicatesBox.add(primaryPredicatesBox);
		predicatesBox.add(secondaryPredicatesBox);
		dDALMASBox.add(predicatesBox);

		// --- NORM-SYSTEM BOX ---
		normsScrollPane.setViewportView(normsList);
		normsScrollPane.setColumnHeaderView(normsLabel);
		normsBox.setPreferredSize(new Dimension(4*WIDTH,3*HEIGHT));
		normsBox.add(normsScrollPane);
		normsBox.add(addNormBtn);
		normSystemBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.yellow),
		"Norm-system"));
		normSystemBox.add(normsBox);
		addNormBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				AddNormFrame addNormFrame = new AddNormFrame(JDALMASGUI.this);
				addNormFrame.setVisible(true);
			}
		});

		groundsScrollPane.setViewportView(groundsList);
		groundsScrollPane.setColumnHeaderView(groundsLabel);
		groundsBox.setPreferredSize(new Dimension(3*WIDTH,3*HEIGHT));
		groundsBox.add(groundsScrollPane);
		groundsBox.add(addGroundBtn);
		normSystemBox.add(groundsBox);
		addGroundBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				AddGroundFrame addGroundFrame = new AddGroundFrame(JDALMASGUI.this);
				addGroundFrame.setVisible(true);
			}
		});

		consequencesScrollPane.setViewportView(consequencesList);
		consequencesScrollPane.setColumnHeaderView(consequencesLabel);
		consequencesBox.setPreferredSize(new Dimension(3*WIDTH,3*HEIGHT));
		consequencesBox.add(consequencesScrollPane);
		consequencesBox.add(addConsequenceBtn);
		normSystemBox.add(consequencesBox);
		addConsequenceBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				AddConsequenceFrame addConsequenceFrame = 
					new AddConsequenceFrame(JDALMASGUI.this);
				addConsequenceFrame.setVisible(true);
			}
		});

		// --- DnrDALMAS BOX ---
		dnrDALMASBox.add(dDALMASBox);
		dnrDALMASBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue), 
		"DnrDALMAS"));
		dnrDALMASBox.add(normSystemBox);

		// --- KNOWLEDGE BASE BOX ---
		knowledgeBaseBox.setPreferredSize(new Dimension(8*WIDTH,3*HEIGHT));
		knowledgeBaseBox.setBorder(BorderFactory.createTitledBorder(
				BorderFactory.createLineBorder(Color.blue),
				"Knowledge Base"));
		knowledgeScrollPane.setViewportView(knowledgeTxt);
		knowledgeBaseBox.add(knowledgeScrollPane);
		knowledgeTxt.setEnabled(false);
		knowledgeTxt.setLineWrap(true);

		// --- MOVING AGENT BOX ---
		agentToMoveBox.setPreferredSize(new Dimension(2*WIDTH,3*HEIGHT));
		agentToMoveBox.setBorder(BorderFactory
				.createTitledBorder(BorderFactory
						.createLineBorder(Color.blue), "Agent to move"));
		agentToMoveLabel.setEnabled(false);
		agentToMoveBox.add(agentToMoveLabel);

		// --- SITUATION PANEL ---
		situationBox.add(knowledgeBaseBox);
		situationBox.add(agentToMoveBox);

		// --- CENTER BOX ---
		centerBox.add(dnrDALMASBox);
		centerBox.add(situationBox);

		// --- MAIN PANEL ---
		this.add(centerBox);
	}
	
	public void setButtonsEnabled(boolean b) {
		this.addActBtn.setEnabled(b);
		this.addAgentBtn.setEnabled(b);
		this.addConsequenceBtn.setEnabled(b);
		this.addGroundBtn.setEnabled(b);
		this.addNormBtn.setEnabled(b);
	}

	public void createController(String host, int port) {
		dnrDALMASController = new DnrDALMASController(host,port,"_");
		dnrDALMASController.addObserver(this);
	}

	public void addAgent(String agentID) {
		if (agentID == null || agentID.equals(""))
			throw new DnrDALMASException("Agent ID must not be empty");
		if (dnrDALMASController.containsAgent(agentID))
			throw new DnrDALMASException("Agent " + agentID + " already exists");
		dnrDALMASController.addAgent(agentID);
		dnrDALMASController.setAgentToMove(agentID);
//		displayDDALMAS();
//		displayAgentToMove();
	}

	public void addAct(String actID) {
		addAct(actID,null);
	}

	public void addAct(String actID, String actParamsString) {
		if (actID == null || actID.equals(""))
			throw new DnrDALMASException("Act ID must not be empty");
		String [] actParams = null;
		if(actParamsString!=null && !actParamsString.equals(""))
			actParams = actParamsString.split(",");
		if (dnrDALMASController.containsAct(actID,actParams))
			throw new DnrDALMASException("Act " + actID + "(" + 
					actParamsString + ") already exists");
		dnrDALMASController.addAct(actID,actParams);
//		displayDDALMAS();
	}

	public void addPredicate(String key, String module, String functor, int arity) {
		if (key == null || key.equals(""))
			throw new DnrDALMASException("Key must not be empty");
		if (functor == null || functor.equals(""))
			throw new DnrDALMASException("Functor must not be empty");
		if (module == null || module.equals(""))
			dnrDALMASController.addPredicate(key,functor,arity);
		else
			dnrDALMASController.addPredicate(key,module,functor,arity);			
//		displayPredicates();
	}

	public void addElementaryNorm(String normID, 
			int groundOpIndex, String groundCondition, String groundConditionParametersString,
			int consequenceOpIndex, String consequenceCondition, String consequenceConditionParametersString) {
		String [] groundConditionParameters = null;
		if(groundConditionParametersString!=null && !groundConditionParametersString.equals(""))
			groundConditionParameters = groundConditionParametersString.split(",");
		String [] consequenceConditionParameters = null;
		if(consequenceConditionParametersString!=null && !consequenceConditionParametersString.equals(""))
			consequenceConditionParameters = consequenceConditionParametersString.split(",");
		dnrDALMASController.addElementaryNorm(normID,groundOpIndex,groundCondition,groundConditionParameters,
				consequenceOpIndex,consequenceCondition,consequenceConditionParameters);
	}

	public void addGroundToGroundSet(String groundID,
			String groundModule, String groundFunctor, int nParams, int nAgents) {
		dnrDALMASController.addGroundToGroundSet(groundID,
				groundModule,groundFunctor,nParams,nAgents);
	}

	public void addConsequenceToConsequenceSet(String consequenceID, 
			String consequenceModule, String consequenceFunctor, 
			int nParams, int nAgents) {
		dnrDALMASController.addConsequenceToConsequenceSet(consequenceID,
				consequenceModule,consequenceFunctor,nParams,nAgents);
	}

	public void displayRun() {
		JOptionPane.showMessageDialog(this,dnrDALMASController.getLatestRun());
	}

	public void displaySituation() {
		displayState();
		displayAgentToMove();
	}

	private void displayAgentToMove() {
		String agentToMove = dnrDALMASController.getAgentToMove();
		agentsList.setSelectedValue(agentToMove,true);
		agentToMoveLabel.setText(dnrDALMASController.getAgentToMove());
	}

	protected void displayState() {
		displayKnowledge();
		displayDnrDALMAS();
	}

	public void displayKnowledge() {
		knowledgeTxt.setText(dnrDALMASController.getCurrentKnowledgeBase().toString());
	}

	protected void displayDnrDALMAS() {
		displayDDALMAS();
		displayNormSystem();
	}

	protected void displayDDALMAS() {
		agentsList.setListData(dnrDALMASController.getAgentSet());
		actsList.setListData(dnrDALMASController.getActSet());
		displayPredicates();
	}

	protected void displayPredicates() {
		choiceSetPredicatePanel.display();
		feasibleActPredicatePanel.display();
		permissibleActPredicatePanel.display();
		turnOperatorPredicatePanel.display();
		tieBreakPredicatePanel.display();
		utilityFunctionPredicatePanel.display();
	}

	protected void displayNormSet() {
		normsList.setListData(dnrDALMASController.getNormSet());		
	}

	protected void displayGroundSet() {
		groundsList.setListData(dnrDALMASController.getGroundSet());		
	}

	protected void displayConsequenceSet() {
		consequencesList.setListData(dnrDALMASController.getConsequenceSet());		
	}

	protected void displayNormSystem() {
		displayNormSet();
		displayGroundSet();
		displayConsequenceSet();
	}

	public void update(Observable observable, Object obj) {
		System.out.println("Update: " + obj.getClass().getName() + " changed");
		displaySituation();
	}

	/**
	 * @return the dnrDALMASController
	 */
	public DnrDALMASController getDnrDALMASController() {
		return dnrDALMASController;
	}

	public String [] getAgentIDs() {
		return dnrDALMASController.getAgentSet();
	}

	Object [] getGroundOps() {
		return dnrDALMASController.getGroundOps();
	}

	Object [] getGroundIDSet() {
		return dnrDALMASController.getGroundIDSet();
	}

	Object [] getGroundSet() {
		return dnrDALMASController.getGroundSet();
	}

	Object [] getConsequenceOps() {
		return dnrDALMASController.getConsequenceOps();
	}

	Object [] getConsequenceIDSet() {
		return dnrDALMASController.getConsequenceIDSet();
	}

	Object [] getConsequenceSet() {
		return dnrDALMASController.getConsequenceSet();
	}
	
	private class PredicatePanel extends JPanel {
		private String predicate;
		private String module;
		private String functor;
		private int arity;
	
		private JLabel predicateLabel = new JLabel();
		private JTextField moduleAndFunctorTxt = new JTextField();
		private JButton updateBtn = new JButton("Update...");
	
		/**
		 * @param parent
		 * @param predicate
		 */
		public PredicatePanel(String predicate) {
			this.predicate = predicate;
			this.setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
			moduleAndFunctorTxt.setEnabled(false);
			this.add(predicateLabel);
			this.add(moduleAndFunctorTxt);
			this.add(updateBtn);
			updateBtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					UpdatePredicateFrame updatePredicateFrame = new UpdatePredicateFrame(
							PredicatePanel.this.predicate,JDALMASGUI.this);
					updatePredicateFrame.setVisible(true);
					updatePredicateFrame.setDefaultCloseOperation(UpdatePredicateFrame.DISPOSE_ON_CLOSE);
				}
			});
		}
	
		public void display() {
			this.module = getDnrDALMASController().getPredicateModule(predicate);
			this.functor = getDnrDALMASController().getPredicateFunctor(predicate);
			this.arity = getDnrDALMASController().getPredicateArity(predicate);
			predicateLabel.setText(" " + predicate + "/" + arity + ": ");
			moduleAndFunctorTxt.setText(module + ":" + functor);
		}
	}
}