package se.hig.jdalmas.gui;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.Box;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;


public class StepNextSituationFrame extends JFrame {
//	private CFDALMASGUI parent;
	private JDALMASGUI jDALMASGUI;
	private Box centerBox = Box.createHorizontalBox();
	private Box actSetBox = Box.createVerticalBox();
	private JList actSetList = new JList();
	private JScrollPane actSetScrollPane = new JScrollPane();
//	private JButton feasibleActsBtn = new JButton("[1] Feasible acts >");
	private Box feasibleActsBox = Box.createVerticalBox();
	private JList feasibleActsList = new JList();
	private JScrollPane feasibleActsScrollPane = new JScrollPane();
	private Box deonticStructureBox = Box.createVerticalBox();
	private JList deonticStructureList = new JList();
	private JScrollPane deonticStructureScrollPane = new JScrollPane();
	private Box preferenceStructureBox = Box.createVerticalBox();
	private JList preferenceStructureList = new JList();
	private JScrollPane preferenceStructureScrollPane = new JScrollPane();
//	private JButton choiceSetBtn = new JButton("[2] Choice set >");
	private Box choiceSetBox = Box.createVerticalBox();
	private JList choiceSetList = new JList();
	private JScrollPane choiceSetScrollPane = new JScrollPane();
	
	public StepNextSituationFrame(JDALMASGUI jDALMASGUI) {
		super("Next situation [" + jDALMASGUI.getDnrDALMASController().getAgentToMove() + "]");
		this.jDALMASGUI = jDALMASGUI;
		initFrame();
	}

	private void initFrame() {
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				jDALMASGUI.setButtonsEnabled(true);
			}
		});
		jDALMASGUI.setButtonsEnabled(false);
		jDALMASGUI.getDnrDALMASController().choiceSet();
		// --- ACT SET PANEL ---
		actSetList.setListData(jDALMASGUI.getDnrDALMASController().getActSet());
		actSetScrollPane.setColumnHeaderView(new JLabel("Act-set"));
		actSetScrollPane.setViewportView(actSetList);
		actSetBox.add(actSetScrollPane);
//		feasibleActsBtn.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent ae) {
////				JDALMASGUI jDALMASGUI = parent.getJDALMASGUI();
//				Object [] feasibleActSet = 
//					jDALMASGUI.getDnrDALMASController().feasibleActSet();
//				feasibleActsList.setListData(feasibleActSet);
//				choiceSetBtn.setEnabled(true);
//			}
//		});
//		actSetBox.add(feasibleActsBtn);
		// --- FEASIBLE ACTS PANEL ---
		feasibleActsList.setListData(jDALMASGUI.getDnrDALMASController().getFeasibleActSet().toArray());
		feasibleActsScrollPane.setColumnHeaderView(new JLabel("Feasible acts"));
		feasibleActsScrollPane.setViewportView(feasibleActsList);
		feasibleActsBox.add(feasibleActsScrollPane);
//		choiceSetBtn.setEnabled(false);
//		choiceSetBtn.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent ae) {
//				Object [] choiceSet = 
//					jDALMASGUI.getDnrDALMASController().choiceSet();
//				choiceSetList.setListData(choiceSet);
//			}
//		});
//		feasibleActsBox.add(choiceSetBtn);

		// --- DEONTIC STRUCTURE PANEL ---
		deonticStructureList.setListData(jDALMASGUI.getDnrDALMASController().getDeonticStructure().toArray());
		deonticStructureScrollPane.setColumnHeaderView(new JLabel("Deontic structure"));
		deonticStructureScrollPane.setViewportView(deonticStructureList);
		deonticStructureBox.add(deonticStructureScrollPane);

		// --- PREFERENCE STRUCTURE PANEL ---
		preferenceStructureList.setListData(jDALMASGUI.getDnrDALMASController().getPreferenceStructure().toArray());
		preferenceStructureScrollPane.setColumnHeaderView(new JLabel("Preference structure"));
		preferenceStructureScrollPane.setViewportView(preferenceStructureList);
		preferenceStructureBox.add(preferenceStructureScrollPane);

		// --- CHOICE-SET PANEL ---
		choiceSetList.setListData(jDALMASGUI.getDnrDALMASController().getChoiceSet().toArray());
		choiceSetScrollPane.setColumnHeaderView(new JLabel("Choice-set"));
		choiceSetScrollPane.setViewportView(choiceSetList);
		choiceSetBox.add(choiceSetScrollPane);

		// --- MAIN FRAME ---
		centerBox.add(actSetBox);
		centerBox.add(feasibleActsBox);
		centerBox.add(deonticStructureBox);
		centerBox.add(preferenceStructureBox);
		centerBox.add(choiceSetBox);
		this.add(centerBox);
		this.pack();
	}
}