package se.hig.jdalmas.gui;

import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import se.hig.jdalmas.exceptions.DnrDALMASException;

public class UpdatePredicateFrame extends JFrame {
	private String predicate;
	private JDALMASGUI parent;
	private Box centerBox = Box.createHorizontalBox();
	private JTextField moduleTxt = new JTextField();
	private JTextField functorTxt = new JTextField();
	private JLabel colonLabel = new JLabel(":");
	private JButton updateBtn = new JButton("Update");
	
	public UpdatePredicateFrame(String predicate, JDALMASGUI parent) {
		super("Update " + predicate);
		this.predicate = predicate;
		this.parent = parent;
		initFrame();
	}

	private void initFrame() {
		this.setPreferredSize(new Dimension(4*parent.WIDTH,3*parent.HEIGHT/2));
		// --- CENTER PANEL ---
		centerBox.add(moduleTxt);
		moduleTxt.setText(parent.getDnrDALMASController().getPredicateModule(predicate));
		centerBox.add(colonLabel);
		centerBox.add(functorTxt);
		functorTxt.setText(parent.getDnrDALMASController().getPredicateFunctor(predicate));
		
		// --- MAIN FRAME ---		
		this.add(centerBox,BorderLayout.CENTER);
		updateBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				String module = moduleTxt.getText();
				String functor = functorTxt.getText();
				int arity = parent.getDnrDALMASController().getPredicateArity(predicate);
				try {
					parent.getDnrDALMASController().addPredicate(predicate,module,functor,arity);
					parent.displayPredicates();
					UpdatePredicateFrame.this.dispose();
				} catch (DnrDALMASException de) {
					JOptionPane.showMessageDialog(UpdatePredicateFrame.this, 
							de.getMessage(),"ERROR",JOptionPane.ERROR_MESSAGE);
				}
			}
		});
		this.add(updateBtn,BorderLayout.SOUTH);
		this.pack();
	}
}
