package se.hig.jdalmas.norms;

import se.hig.jdalmas.GenericComponent;

public class ElementaryNorm extends GenericComponent implements Norm {
	protected String normSystemID;
	protected String normID;
	protected ElementaryGround ground;
	protected ElementaryConsequence consequence;

	/**
	 * @param normSystemID
	 * @param normID
	 * @param consequence
	 * @param ground
	 */
	public ElementaryNorm(String normSystemID, String normID, ElementaryGround ground, ElementaryConsequence consequence) {
		this.normSystemID = normSystemID;
		this.normID = normID;
		this.ground = ground;
		this.consequence = consequence;
	}

	/**
	 * @return the consequence
	 */
	public ElementaryConsequence getConsequence() {
		return consequence;
	}

	/**
	 * @return the ground
	 */
	public ElementaryGround getGround() {
		return ground;
	}

	/**
	 * @return the normSystemID
	 */
	public String getNormSystemID() {
		return normSystemID;
	}

	/**
	 * @return the normID
	 */
	public String getNormID() {
		return normID;
	}

	
	/* (non-Javadoc)
	 * @see se.hig.jdalmas.norms.Norm#isElementary()
	 */
	public boolean isElementary() {
		return true;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return normID + "[" + ground.toString() + " --> " + consequence.toString() + "]";
	}

}