package se.hig.jdalmas.norms;

import java.util.Map;

import se.hig.jdalmas.DnrDALMAS;
import se.hig.jdalmas.DnrDALMASSituation;
import se.hig.jdalmas.DnrDALMASState;
import se.hig.jdalmas.GenericComponent;
import se.sics.prologbeans.PBTerm;

public abstract class Ground extends GenericComponent {
	protected String booleanConnective = null;
	protected SitCondition [] sitConds = null;
	
	public String getBooleanConnective() {
		return this.booleanConnective;
	}

	public SitCondition getSitCond(int i) {
		return this.sitConds[i];
	}

	public boolean isElementary() {
		return (this.booleanConnective == null);
	}
	
	public static PBTerm createPrologTerm(Ground ground) {
		if (ground.isElementary())
			return SitCondition.createPrologTerm(ground.getSitCond(0));
		// TODO: handle non-elementary grounds!
		return null;
	}

	public static ElementaryGround createGround(PBTerm groundTerm) {
		return new ElementaryGround(SitCondition.createSitCond(groundTerm));
	}

	public static ElementaryGround createElementaryGround(DnrDALMASSituation currentSituation, 
			Operator groundOp,String groundConditionID, String[] groundConditionParameters) {
		DnrDALMASState state = currentSituation.getState();
		DnrDALMAS dnrDALMAS = state.getDnrDALMAS();
		NormSystem normSystem = dnrDALMAS.getNormSystem();
		Map<String,StateCondition> groundSet = normSystem.getGroundSet();
		return createElementaryGround(groundOp,
				groundConditionID,groundConditionParameters,groundSet);
	}

	public static ElementaryGround createElementaryGround(Operator groundOp, 
			String groundConditionID, 
			String [] groundConditionParameters, 
			Map<String, StateCondition> groundSet) {
		if (!groundSet.containsKey(groundConditionID))
			return null;
		SitCondition sitCond = new SitCondition(groundOp,groundConditionID,
				groundConditionParameters);
		return new ElementaryGround(sitCond);
	}

}