package se.hig.jdalmas.norms;

import se.hig.jdalmas.GenericComponent;
import se.sics.prologbeans.PBTerm;

public class StateCondition extends GenericComponent {
	protected String module;
	protected String functor;
	protected int parameters;
	protected int agentArguments;

	
	/**
	 * @param module
	 * @param functor
	 * @param parameters
	 * @param agentArguments
	 */
	public StateCondition(String module, String functor, int parameters, int agentArguments) {
		this.module = module;
		this.functor = functor;
		this.parameters = parameters;
		this.agentArguments = agentArguments;
	}

	/**
	 * @param functor
	 * @param parameters
	 * @param agentArguments
	 */
	public StateCondition(String functor, int parameters, int agentArguments) {
		this("user",functor,parameters,agentArguments);
	}

	
	/**
	 * @return the stateCondID
	 */
	public String getFunctor() {
		return functor;
	}

	/**
	 * @return the agentArguments
	 */
	public int getAgentArguments() {
		return agentArguments;
	}

	/**
	 * @return the parameters
	 */
	public int getParameters() {
		return parameters;
	}

	/**
	 * @return the module
	 */
	public String getModule() {
		return module;
	}

	public String toString() {
		return this.module + ":" 
		+ this.functor + "/" + this.parameters + "/" + this.agentArguments;
	}

	public static StateCondition createStateCondition(String module, String functor, 
			int parameters, int agentArguments) {
		return new StateCondition(module,functor,parameters,agentArguments);
	}

	public static StateCondition createStateCondition(PBTerm gcTerm, PBTerm parametersTerm, 
			PBTerm agentArgumentsTerm) {
		String module = gcTerm.getArgument(1).toString();
		String functor = gcTerm.getArgument(2).toString();
		int parameters = (int)parametersTerm.intValue();
		int agentArguments = (int)agentArgumentsTerm.intValue();
		return createStateCondition(module,functor,parameters,agentArguments);
	}
}